/*****************************************************************************
 *  line.c: contains function for searching strings in line
 *  This is part of httpaccess program.
 *  Copyright (C) 2001  Silvio Klaic, sklaic@student.math.hr
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *****************************************************************************/

#include <stdio.h>
#include <string.h>

short int isinline(char *lin, char *name)
{/* find substring of name in line */
int i,j,k;
short int res=0;

k=strlen(name)-1;/* size of file name */
if(strlen(lin)>(k+20)){/* ok line is bigger, it's possible that word is here */
 i=0;j=0;while((j<k)&&(lin[i]!=0)){/* scan line */
 if(lin[i]==name[j]) j++; else j=0; i++;
 if(j>=k) res=1;
 }/* end for while */
}/* end if line bigger */
return(res);
}/* end isinline() */

void get_date(char *lin, char *newdate)
{/* extract and sort date */
int i,j,k;
char ch[25];

k=strlen(lin);
i=0;while((lin[i]!='[')&&(i<k)) i++;i++;/* find first date mark */
for(j=i;j<i+20;j++) ch[j-i]=lin[j];ch[j-i]=0;/* copy date & make string */
newdate[0]=ch[7];newdate[1]=ch[8];newdate[2]=ch[9];newdate[3]=ch[10];/* year */
newdate[4]='/';switch (ch[3]){/* check month */
 case 'J':/* Jan, Jun, Jul */
	 if(ch[4]=='a'){ newdate[5]='0';newdate[6]='1';/* Jan */
	 }else if(ch[5]=='n'){ newdate[5]='0';newdate[6]='6';/* Jun */
	  }else{ newdate[5]='0';newdate[6]='7';/* Jul */
	  } break;
 case 'F':/* Feb */
	  newdate[5]='0';newdate[6]='2';break;
 case 'M':/* Mar, May */
	  if(ch[5]=='r'){ newdate[5]='0';newdate[6]='3';/* Mar */
	  }else{ newdate[5]='0';newdate[6]='5';/* May */
	  } break;
 case 'A':/* Apr, Aug */
	  if(ch[4]=='p'){ newdate[5]='0';newdate[6]='4';/* Apr */
	  }else{ newdate[5]='0';newdate[6]='8';/* Aug */
	  } break;
 case 'S':/* Sep */
	  newdate[5]='0';newdate[6]='9';break;
 case 'O':/* Oct */
	  newdate[5]='1';newdate[6]='0';break;
 case 'N':/* Nov */
	  newdate[5]='1';newdate[6]='1';break;
 case 'D':/* Dec */
	  newdate[5]='1';newdate[6]='2';break;
 default: printf("Whoa, whats that? don't recognize this as a date: [%s]\n",ch);
	  break;
} newdate[7]='/';newdate[8]=ch[0];newdate[9]=ch[1];/* end switch */
for(i=11;i<=20;i++) newdate[i-1]=ch[i];/* copy rest of date */
}/* end get_date */
